﻿import flash.filters.ColorMatrixFilter;
class com.rubenbristian.display.HexToCMF {
	public function HexToCMF(target:MovieClip, hex:Number, alpha:Number) {
		//get the values
		if (hex>0) {//if hex is a normal color value
			var hexObj:Object = hexToRGB(hex);//rgb object
			var red:Number = hexObj.red/255;//red value
			var green:Number = hexObj.green/255;//green value
			var blue:Number = hexObj.blue/255;//blue value
			alpha == undefined ? alpha=1 : alpha /= 100;//alpha value
			var targetMatrix:ColorMatrixFilter = new ColorMatrixFilter([red, 0, 0, 0, 0, 0, green, 0, 0, 0, 0, 0, blue, 0, 0, 0, 0, 0, alpha, 0]);//create the color matrix filter based on the desired properties
			target.filters = [targetMatrix];//apply the filter to the targeted movieclip
		} else if (hex == -1) {//if hex is -1
			var targetMatrix:ColorMatrixFilter = new ColorMatrixFilter([1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0]);//create the default color matrix filter
			target.filters = [targetMatrix];//apply the filter to the targeted movieclip
		}
	}
	//function that converts from hex to rgb. returns a object with "red", "green", "blue" properties
	public function hexToRGB(hex:Number) {
		var returnObj:Object = new Object();
		returnObj.red = hex >> 16;
		var temp = hex ^ returnObj.red << 16;
		returnObj.green = temp >> 8;
		returnObj.blue = temp ^ returnObj.green << 8;
		return returnObj;
	}
}